v7.3.0
SupportExamplesFree Trial

Binding Bryntum Scheduler Pro data

Bryntum Scheduler Pro is a data intensive component that uses several datasets. These datasets usually come from the server and are held in SchedulerPro project during the lifetime of the SchedulerPro view. There are several ways of populating the project data stores.

Using project transport

ProjectModel supports loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring project with transport is the simplest way of binding data to the SchedulerPro project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration can be as simple as setting the project property like this:

schedulerproProps: {
    project : {
        loadUrl  : '/server/load/url',
        syncUrl  : '/server/save/url',
        autoLoad : true
    }
}

<BryntumSchedulerPro {...schedulerproProps}/>

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for SchedulerPro is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as Angular component class variables and then use them in templates:

app.ts:

import { Component, OnInit } from '@angular/core';
import { schedulerProProps } from './app.config';
import { DataService } from './data.service';

@Component({
    selector    : 'app-root',
    templateUrl : './app.component.html',
    styleUrls   : ['./app.component.scss'],
    providers   : [DataService]
})
export class App implements OnInit {

    events = [];
    dependencies = [];
    resources = [];
    assignments = [];
    calendars = [];
    timeRanges = [];

    schedulerProProps = schedulerProProps;

    // Inject data service
    constructor(private dataService: DataService) {}

    ngOnInit(): void {
        // Get initial data
        Object.assign(this, this.dataService.getData());
    }
}

app.html:

<bryntum-scheduler-pro
    #schedulerpro
    [viewPreset] = "schedulerProProps.viewPreset!"
    [columns] = "schedulerProProps.columns!"
    [assignments] = "assignments"
    [calendars] = "calendars"
    [dependencies] = "dependencies"
    [events] = "events"
    [resources] = "resources"
    [timeRanges] = "timeRanges"
></bryntum-scheduler-pro>

DataService is a placeholder name in this example and it would be replaced by the service that provides data in your application.

The key is to supply existing data to the class variables and then use these variables in the template.

Binding existing data to the project

This approach binds data to a standalone SchedulerProProjectModel component and then uses this project in SchedulerPro. Project has its own markup in the template and it must be assigned to the SchedulerPro during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

app.ts:

import { Component, OnInit } from '@angular/core';
import { schedulerProProps, projectProps } from './app.config';
import { DataService } from './data.service';

@Component({
    selector    : 'app-root',
    templateUrl : './app.component.html',
    styleUrls   : ['./app.component.scss'],
    providers   : [DataService]
})
export class App implements OnInit {

    events = [];
    dependencies = [];
    resources = [];
    assignments = [];
    calendars = [];
    timeRanges = [];

    schedulerProProps = schedulerProProps;
    projectProps = projectProps;

    // Inject data service
    constructor(private dataService: DataService) {}

    ngOnInit(): void {
        // Get initial data
        Object.assign(this, this.dataService.getData());
    }
}

app.html:

<bryntum-scheduler-pro-project-model
    #project
    [startDate] = "projectProps.startDate!"
    [assignments] = "assignments"
    [calendars] = "calendars"
    [dependencies] = "dependencies"
    [events] = "events"
    [resources] = "resources"
    [timeRanges] = "timeRanges"
></bryntum-scheduler-pro-project-model>

<bryntum-scheduler-pro
    #schedulerpro
    [columns] = "schedulerProProps.columns!"
    [project] = "project"
></bryntum-scheduler-pro>
Note that bryntum-schedulerpro-project-model tag must come before all other components that use it. Otherwise the #project reference is not valid to these components.

DataService is a placeholder name in this example and it would be replaced by the service that provides data in your application.

Check implementation in inline-data Angular demo.

Contents

v7.3.0
SupportExamplesFree Trial

Binding Bryntum Scheduler Pro data

Bryntum Scheduler Pro is a data intensive component that uses several datasets. These datasets usually come from the server and are held in SchedulerPro project during the lifetime of the SchedulerPro view. There are several ways of populating the project data stores.

Using project transport

ProjectModel supports loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring project with transport is the simplest way of binding data to the SchedulerPro project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration can be as simple as setting the project property like this:

schedulerproProps: {
    project : {
        loadUrl  : '/server/load/url',
        syncUrl  : '/server/save/url',
        autoLoad : true
    }
}

<BryntumSchedulerPro {...schedulerproProps}/>

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for SchedulerPro is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as state variables and set these as properties of the React component:

App.js:

import React, { useState } from 'react';

import { schedulerProProps } from './AppConfig';
import { projectData } from './AppData';

import './App.scss';

function App() {
    const [events, setEvents] = useState(projectData.events);
    const [assignments, setAssignments] = useState(projectData.assignments);
    const [dependencies, setDependencies] = useState(projectData.dependencies);
    const [resources, setResources] = useState(projectData.resources);

    return (
        <BryntumSchedulerPro
            ref = {schedulerpro}
            events = {events}
            assignments = {assignments}
            dependencies = {dependencies}
            resources = {resources}
            {...schedulerProProps}
        />
    );
}

export default App;

Here we have state variables, one per data set, together with their setters so whenever a change of data is needed the setter needs to be called with new data as the argument and the change will be immediately reflected in the SchedulerPro.

For example:

setEvents(newEvents);
setResources(newResources);
When binding to data, the same principles as for React state applies - an object in the incoming data must be replaced instead of mutated for a change to be detected ( explained by the React team here).

If you cannot follow best practise and have to mutate the objects, you can configure the underlying store with useRawData: false. It will then clone the incoming objects and can thus detect mutations when state is reapplied, trading performance for flexibility (docs here).

Binding existing data to the project

This approach binds data to a standalone SchedulerProProjectModel and then uses this project in SchedulerPro. Project has its own markup in the template and it must be assigned to the SchedulerPro during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

App.js:

import React, { useState } from 'react';

import { schedulerProProps, projectProps } from './AppConfig';
import { projectData } from './AppData';

import './App.scss';

function App() {
    const schedulerpro = useRef();
    const project = useRef();

    const [events, setEvents] = useState(projectData.events);
    const [assignments, setAssignments] = useState(projectData.assignments);
    const [dependencies, setDependencies] = useState(projectData.dependencies);
    const [resources, setResources] = useState(projectData.resources);

    return (
        <>
            <BryntumSchedulerProProjectModel
                ref = {project}
                events = {events}
                assignments = {assignments}
                dependencies = {dependencies}
                resources = {resources}
                {...projectProps}
            />
            <BryntumSchedulerPro
                ref = {schedulerpro}
                project = {project}
                {...schedulerProProps}
            />
        </>
    );
}

export default App;

Here we create a standalone SchedulerProProjectModel (without any rendered output) with properties bound to individual data sets. The project must be assigned to SchedulerPro in useEffect which is configured to run only once on component mount.

Note that BryntumSchedulerProProjectModel must be returned first for other components to use it. Otherwise the SchedulerPro appears blank, without any data.

Check implementation in inline-data React demo.

Working with Redux

Bryntum components can also be integrated with a Redux Store using the same workflow that you would use to manage the state of a traditional React project.

To see this in action, you can try out our Bryntum Taskboard React + Redux demo.

Contents

v7.3.0
SupportExamplesFree Trial

Binding Bryntum Scheduler Pro data

Bryntum Scheduler Pro is a data intensive component that uses several datasets. These datasets usually come from the server and are held in SchedulerPro project during the lifetime of the SchedulerPro view. There are several ways of populating the project data stores.

Using project transport

ProjectModel supports loading and saving of data in multiple stores with transport config. Loading the stores and saving all changes is done in one request.

Configuring project with transport is the simplest way of binding data to the SchedulerPro project stores as seen from the client side, but it does require following a specific protocol on the backend.

The configuration can be as simple as setting the project property like this:

schedulerproProps: {
    project : {
        loadUrl  : '/server/load/url',
        syncUrl  : '/server/save/url',
        autoLoad : true
    }
}

<BryntumSchedulerPro {...schedulerproProps}/>

With this configuration, the data is loaded and saved from and to the above URLs and the data transport is handled automatically.

Binding existing data to the component

When the application already has a server transport layer then the data for SchedulerPro is available in application code and it needs to be passed (bound) to the component. One approach is to make the data available as component variables and bind them in the Vue template:

App.vue:

<template>
    <bryntum-scheduler-pro
        :assignments = "assignments"
        :calendars = "calendars"
        :dependencies = "dependencies"
        :resources = "resources"
        :events = "events"
        v-bind = "schedulerProProps"
    />
</template>

<script>
import { ref, reactive } from 'vue';

import { BryntumSchedulerPro } from '@bryntum/schedulerpro-vue-3';

import { useschedulerProProps } from '@/AppConfig';
import * as appData from '@/AppData';

export default {
    name : 'App',

    components : {
        BryntumSchedulerPro
    },

    setup() {
        const schedulerProProps = reactive(useschedulerProProps());

        const assignments = ref(appData.assignments);
        const calendars = ref(appData.calendars);
        const dependencies = ref(appData.dependencies);
        const resources = ref(appData.resources);
        const events = ref(appData.events);

        return {
            schedulerProProps,
            assignments,
            calendars,
            dependencies,
            resources,
            events
        };
    }
};
</script>

<style lang = "scss">
@import './App.scss';
</style>

Here we have component variables, initialized by spreading ...initialData. Whenever a change of the data is needed, it is only necessary to assign the new values to these variables, for example:

this.events = newEvents;
this.dependencies = newDependencies;

Binding existing data to the project

This approach binds data to a standalone SchedulerProProjectModel and then uses this project in SchedulerPro. Project has its own markup in the template and it must be assigned to the SchedulerPro during initialization.

This approach is suitable for more complex applications that use more than one Bryntum component that share a common project:

App.vue:

<template>
    <div>
        <bryntum-scheduler-pro-project-model
            ref = "project"
            :assignments = "assignments"
            :calendars = "calendars"
            :dependencies = "dependencies"
            :resources = "resources"
            :events = "events"
        />
        <bryntum-scheduler-pro
            :project = "project"
            v-bind = "schedulerProProps"
        />
    </div>
</template>

<script>
import { ref, reactive } from 'vue';

import { BryntumSchedulerProProjectModel, BryntumSchedulerPro } from '@bryntum/schedulerpro-vue-3';

import { useschedulerProProps } from '@/AppConfig';
import * as appData from '@/AppData';

export default {
    name : 'App',

    components : {
        BryntumSchedulerProProjectModel,
        BryntumSchedulerPro
    },

    setup() {
        const project = ref(null);

        const schedulerProProps = reactive(useschedulerProProps());

        const assignments = ref(appData.assignments);
        const calendars = ref(appData.calendars);
        const dependencies = ref(appData.dependencies);
        const resources = ref(appData.resources);
        const events = ref(appData.events);

        return {
            project,
            schedulerProProps,
            assignments,
            dependencies,
            calendars,
            events,
            resources
        };
    }
};
</script>

<style lang = "scss">
@import './App.scss';
</style>

Here we create a standalone SchedulerProProjectModel (without any rendered output) with properties bound to individual data sets.

Note that bryntum-schedulerpro-project-model tag must come before all other components that use it. Otherwise the project reference is not valid to these components.

Check implementation in React inline-data demo.

Contents